"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class API(ProtocolElement):
    """
    Represents the contract of API dependency (either REST or OTHER)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "description",
        "status",
        "type",
        "url",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import system as system_0_1_0

        return {
            "status": system_0_1_0.Status,
            "type": system_0_1_0.APIType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import system as system_0_1_0

        return {
            "org.gel.models.system.avro.Status": system_0_1_0.Status,
            "org.gel.models.system.avro.APIType": system_0_1_0.APIType,
            "org.gel.models.system.avro.API": system_0_1_0.API,
        }

    __slots__ = [
        "description",
        "status",
        "type",
        "url",
        "additionalProperties",
    ]

    def __init__(
        self,
        description,
        status,
        type,
        url,
        additionalProperties=None,
        validate=None,
        **kwargs
    ):
        """Initialise the system_0_1_0.API model.

        :param description:
        :type description: str
        :param status:
        :type status: Status
        :param type:
        :type type: APIType
        :param url:
        :type url: list[str]
        :param additionalProperties:
        :type additionalProperties: None | dict[str, str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "0.1.0"
